//*************************************************************
// I2C LCD Cu@PIC18  Ver 2.0 20130512
// ȉ̋@\񋟂
//
//    LCD_int()     ----- (I2C܂)
//    LCD_cmd(cmd)  ----- R}ho
//    LCD_dat(chr)  ----- P\
//    LCD_str(*str) ----- \
//    LCD_ROMstr(*str) -- ROM\
//    LCD_hex(char);
//    LCD_posyx(y,x) ---- J[\ʒuwAs yAʒu x
//    LCD_clr()     ----- S
//    LCD_icon_on(icn); -- wACR ON
//    LCD_icon_off(icn);-- wACR OFF
//    LCD_icon_clr();----- SACR OFF
//
//t\PICI2Cɂڑ
//     1)Define I/O PORT
//         PORTB(4)pin13    :  SDA
//         PORTB(6)pin11    :  SCL
//     2)OSC
//         NbN@4MHz 
//
// Copyright (c) 2012-2013 iwamoto All Rights Reserved
//************* Delay *******************************************
// KvƂfBCԂNbNgvZA
// w肷邽߂ɁANbNgw肷B
//***************************************************************
//#define _XTAL_FREQ 4000000 
#define _XTAL_FREQ 32000000 

//
//*************** Delay Define for 4MHz Clock*********
#define  Delay_50uS   __delay_us(50)
#define  Delay_2mS    __delay_ms(2)  
//#define  Delay_100mS  __delay_ms(100) 
#define  Delay_100mS  __delay_ms(10);__delay_ms(10);__delay_ms(10);__delay_ms(10);__delay_ms(10);__delay_ms(10);__delay_ms(10);__delay_ms(10);__delay_ms(10);__delay_ms(10);
//********************************
//  p萔
//*********************************
//#define CONTRAST  0x2D		// for 3.3V
// #define CONTRAST  0x18		// for 5.0V
#define CONTRAST  0x09			// for 5.0VHI2cڑ^t

//********************************
//  {[[g萔
//********************************
// --------- for  4MHz ------------
#define SlewCont   SLEW_OFF    // Slew Rate 100K
#define BaudConst  0x09        // BRG Value for 4MHz

// --------- for  48MHz ------------
//#define SlewCont   SLEW_ON     // Slew Rate 400K
//#define BaudConst  0x1D        // BRG Value for 48MHz

//********************************
//  ACR萔
//*********************************
#define i_Ant  0x4010		// Aei
#define i_Tel  0x4210		// db
#define i_Aud  0x4410		// 
#define i_Pulg  0x4610		// ڑ
#define i_Up  0x4710		// Up
#define i_Dn  0x4708		// Down
#define i_UpDn  0x4718		// Down
#define i_Lock  0x4910		// 
#define i_XFlag  0x4B10		// X
#define i_BatEMP  0x4D02	// obe[
#define i_BatLOW  0x4D12	// obe[
#define i_BatMID  0x4D1A	// obe[
#define i_BatFUL  0x4D1E	// obe[
#define i_Circle  0x4F10	// Od

//******************* 񋟋@\ *******************************
void LCD_dat(char chr);
void LCD_cmd(char cmd);
void LCD_clr(void);
void LCD_int(void);
void LCD_str(char *str);
void LCD_posyx(char ypos,char xpos);
void LCD_icon_on(int icn);
void LCD_icon_off(int icn);
void LCD_icon_clr(void);
void LCD_ROMstr(const char *);
void LCD_hex(char);
