/*******************************************************************************

_ov
gp`bv:PIC18F14K50

I2CڑLCD̃Cu http://sky.geocities.jp/home_iwamoto/page/P14K50/P14_B02.htm
Xgx[ibNXАI2CڑLCDp_E[hBςĎgp
I2CڑLCD̃Cu̒쌠2012-2013 iwamoto All Rights Reserved
ϕ
diff-orig-L_i2cLCD.h-mod-L_i2cLCD.h.txt
diff-orig-L_i2cLCD.c-mod-L_i2cLCD.c.txt
QƂ̂


{t@C̒쌠͕܂B
*******************************************************************************/
#include <xc.h>			// delaypɕKv
#include <pwm.h> // ̂Ƃxc8 1.35ɂpwm.hȂ̂ł1.35ł̓RpCłȂ
#include <stdio.h>
#include "L_i2cLCD.h"    //I2CڑLCD֐


#ifndef _XTAL_FREQ
#define _XTAL_FREQ   32000000			// delaypɕKv
#endif

#pragma config CPUDIV = NOCLKDIV
#pragma config FOSC   = IRC
#pragma config PLLEN  = ON
#pragma config FCMEN  = OFF
#pragma config IESO   = OFF
#pragma config PWRTEN = OFF
#pragma config BOREN  = ON
#pragma config BORV   = 30
#pragma config WDTEN  = OFF
#pragma config WDTPS  = 32768
#pragma config MCLRE  = OFF
#pragma config HFOFST = OFF
#pragma config STVREN = OFF
#pragma config LVP    = OFF
#pragma config XINST  = OFF
#pragma config BBSIZ  = OFF
#pragma config CP0    = OFF
#pragma config CP1    = OFF
#pragma config CPB    = OFF
#pragma config WRT0   = OFF
#pragma config WRT1   = OFF
#pragma config WRTB   = OFF
#pragma config WRTC   = OFF
#pragma config EBTR0  = OFF
#pragma config EBTR1  = OFF
#pragma config EBTRB  = OFF


#define TMR0_PERIOD	(65536-10000)		// 100HzƂȂ悤
#define PWM_DS		0b01000000			// uU[pPWM
#define LED		LATAbits.LATA5			// o\
#define LIGHT	LATCbits.LATC0			// tgCgorobNCg

#define WINDOW_SIZE 14		// ECh[TCY(_𒲍͈)
#define HEIGHT_DIFF 7		// ʂ̊ȏォ̃`FbNɗp
#define ALLOWED_SCALE 3		// ̊̈܂ł̏㉺͖
#define SKIP_SIZE 26		// _oXLbv͈
#define BEEP_PERIOD 2
#define BEEP_HOLD_PERIOD 8
#define DISP_HOLD_COUNTER_NUM 200	// 4b
#define ALLOWED_PULSE_DIFF 3		// ̊܂ł̖̂Ԃ͈͓͒̔Ƃ
#define LEDON 0		// z݂ON
#define LEDOFF 1
#define LIGHTON 0	// z݂ON
#define LIGHTOFF 1


/** RS 232 lines ****************************************************/
#define UART_TRISTx   TRISBbits.TRISB7
#define UART_TRISRx   TRISBbits.TRISB5
#define UART_Tx       PORTBbits.RB7
#define UART_Rx       PORTBbits.RB5
#define UART_ENABLE   RCSTAbits.SPEN


void interrupt HighInterrupt(void);
void interrupt low_priority LowInterrupt(void);
void initialize(void);
void InitializeUSART(void);
void UART_putc(unsigned char c);
void putcUSART(char c);
unsigned char getcUSART ();


/****************************** DECLARATIONS ********************************/
unsigned char counter_beep = 0;			// uU[pJE^
unsigned char counter_hold = 0;		// 햬õz[h\pJE^
unsigned char flg_beep = 0;				// Ɋ֌WȂԌuU[Ȃz[hɎgp
int prevValue = 0;
int currentValue;
int diff;
int maxValue = 0;
int minValue = 0;
unsigned char index_max = 0;
int allowed_unevenness = 0;
int ad_array[WINDOW_SIZE] = {0};
int ad_array_fixed[WINDOW_SIZE] = {0};
unsigned char index_array = 0;
unsigned char index_array_current = 0;
unsigned char skip_cntr_initial = 0;
unsigned char skip_cntr = 0;

unsigned int counter_last = 0;
unsigned int counter_bef_last = 0;
unsigned int counter_past = 0;
unsigned int counter_bef_past = 0;

unsigned int misalign_bef_last = 0;
unsigned int misalign_last = 0;
unsigned int sum = 0;
unsigned int pulse = 0;
unsigned int pulse_disp = 0;		// E\l
unsigned int pulse_stable = 0;		// El
unsigned int pulse_past = 0;		// EO
unsigned int pulse_bef_past = 0;	// EQO
unsigned int pulse_bef_bef_past = 0;// ERO
unsigned int pulse_min = 0;
unsigned int pulse_max = 0;
unsigned int pulse_diff = 999;
unsigned int pulse_sum = 0;
unsigned char flg_max = 0;
unsigned char flg_fill = 0;	// TvƂ\tO
unsigned char flg_just = 0;	// ŏ̃Tv̂Ă鐧Ȃׂ̃tO


/**************************** MAIN ROUTINE ************************************/
void main(void)
{
	initialize();               // call initialize routine

	while(1) {
	}
}// end main
/******************************************************************************/

/**************************** INITIALIZE ROUTINE ******************************/
void initialize(void)
{
    char msgStart[] ="     bpm";

	OSCCON = 0b01100000;	// NbN8MHz(PLLɂ32MHzœ)
	TRISA = 0b11011111;	//RA4 is input for ADC, RA5 is output for LED
	TRISB = 0b11111111;	//RB4 and RB6 are inputs for I2C
//	TRISC = 0b11011111;	//RC5 is output for CCP1
	TRISC = 0b11011110;	//RC0,RC5 are output

	// for ADC
	ANSEL =  0b00001000;	// Digital RC5(AN3) is disabled
	ANSELH = 0b00000000;
//	ADCON0 = 0b00001100;	// AN3 selected
//	ADCON1 = 0b00001000;	// FVR <--> VSS
//	ADCON2 = 0b10010101;	// 4 TAD, FOSC/16
	REFCON0 = 0b10100000;	// FVR = 2.048V

	RCONbits.IPEN=1;		// Enable priority levels on interrupts
	INTCON2bits.TMR0IP=1;		// High priority

	INTCONbits.GIEL = 1;
	INTCONbits.GIEH = 1;


	InitializeUSART();


    LCD_int();                 // LCD
    LCD_str(msgStart);         // LCDi"bpm"


	WriteTimer0(TMR0_PERIOD);
	OpenADC(ADC_FOSC_32 & ADC_16_TAD & ADC_RIGHT_JUST,
			ADC_CH3 & ADC_INT_OFF,
			ADC_REF_VDD_FVREF & ADC_REF_VDD_VSS,
			ANSEL);

	OpenTimer0(T0_16BIT & T0_SOURCE_INT & T0_PS_1_16);	// T0_PS_1_16ł傤50Hz
//	OpenTimer0(T0_16BIT & T0_SOURCE_INT & T0_PS_1_8);	// T0_PS_1_8ł傤100Hz



	OpenPWM1 (PWM_DS);
	OpenTimer2(TIMER_INT_OFF & T2_PS_1_16 & T2_POST_1_1);
	SetDCPWM1 (0);

	LED=LEDOFF;
	LIGHT=LIGHTOFF;

}//end initialize
/******************************************************************************/

/*************************** ISR ROUTINE **************************************/
void interrupt HighInterrupt(void)
{
	char Buf[9];
	int adval;
	unsigned char  i,j;
	unsigned int bar;
	unsigned char barmax;


    if(INTCONbits.T0IF)  // If Timer flag is set & Interrupt is enabled
    {                              
		INTCONbits.T0IF = 0;            // Clear the interrupt flag
		WriteTimer0(TMR0_PERIOD);


		ConvertADC();				// ADϊJn
		while(BusyADC());			// ADϊI҂
		adval = ReadADC();


		if(adval==0x3FF)	// 10bitADC̖Oal
			flg_max=1;


		// JpVAo
		sprintf(Buf, "%d,", adval);
		putsUSART(Buf);



		// ADlo[Ot\
		bar=adval>>4;
		
    	LCD_posyx(1,0);

		if(bar>8)
			barmax=8;
		else
			barmax=bar;

		for(i=0;i<barmax;i++)
			LCD_dat(0xff);

		for(i=barmax;i<8;i++)
			LCD_dat(' ');



/*
//		sprintf(Buf, "%8d", (int)adval);
		sprintf(Buf, "%8d", diff);

		for(i=0;i<8;i++)
		{
	    	if(Buf[i]!=NULL)
	   		LCD_dat(Buf[i]);
	    	else	//lߕ\ɈӖ
	    	{	
	    		for(j=i;j<8;j++)
	    			LCD_dat(' ');
	    		break;
	    	}
		}
*/

		// uU[ALEDE

		// 햬õz[h\̏ꍇ
		// uU[̊Ԍ͖Ɋ֌WȂAƎ^C~OłȂ
		if(counter_hold)
		{
			// uU[̖I^C~O
			// uU[x~ԂI^C~Ȍꍇ
			if(!(counter_beep))
			{
				if(flg_beep)	// uU[̖I^C~Ȍꍇ
				{
					SetDCPWM1(0);
					// 鎞ԂƁÅԂ̋x~Ԃ͓BJE^[p
					counter_beep=BEEP_HOLD_PERIOD;
					flg_beep=0;
					LED=LEDOFF;
				}
				else	// uU[x~ԂI^C~Ȍꍇ
				{
					SetDCPWM1(PWM_DS);
					counter_beep=BEEP_HOLD_PERIOD;
					flg_beep=1;
					LED=LEDON;
				}
			}

			counter_beep--;
			counter_hold--;

			if(counter_hold==0)
			{
				LIGHT=LIGHTOFF;
				counter_bef_past = 0;
				counter_past = 0;
				counter_bef_last = 0;
			}
		}
		// ʏ펞
		// uU[͖ɍ킹Ė
		else
		{
			if(!counter_beep)
			{
				SetDCPWM1(0);
				LED=LEDOFF;
			}
			else
				counter_beep--;
		}


		counter_last++;



		ad_array[index_array]=adval;

		index_array_current=index_array;

		index_array++;
		if(index_array==WINDOW_SIZE)
			index_array=0;


		// z񂪖܂ł͂ŏI
	    if (skip_cntr_initial < WINDOW_SIZE-1){
	        skip_cntr_initial++;
	        return;    
	    }


		//CfbNX0n܂zɍ蒼
		if(index_array_current!=(WINDOW_SIZE-1))
		{
			j=0;
			for(i=index_array_current+1;i<WINDOW_SIZE;i++)
			{
				ad_array_fixed[j]=ad_array[i];
				j++;
			}
			for(i=0;i<=index_array_current;i++)
			{
				ad_array_fixed[j]=ad_array[i];
				j++;
			}
		}else
		{
			for(i=0;i<WINDOW_SIZE;i++)
				ad_array_fixed[i]=ad_array[i];
		}




		// _oSKIP_SIZE̕XLbv
		if(skip_cntr)
		{
			skip_cntr--;
			return;
		}


		// maxlƂ̎index擾
		maxValue=0;
		index_max=0xFF;
		for(i=0;i<WINDOW_SIZE;i++)
		{
			if(ad_array_fixed[i]>maxValue)
			{
				maxValue=ad_array_fixed[i];
				index_max=i;
			}
		}

		// minl擾
		minValue=maxValue;
		for(i=0;i<WINDOW_SIZE;i++)
		{
			if(ad_array_fixed[i]<minValue)
			{
				minValue=ad_array_fixed[i];
			}
		}

		allowed_unevenness=(maxValue-minValue)/ALLOWED_SCALE;



		// z̒gS0̏ꍇ͂ŏI
		if(index_max==0xFF)
			return;


		// l_̌`(R`)ɕł邩`FbN
		prevValue=ad_array_fixed[0];
		for(i=1;i<WINDOW_SIZE;i++)
		{
			diff = ad_array_fixed[i] - prevValue;
			prevValue = ad_array_fixed[i];

			// maxl܂łallowed_unevennessӏ΂ŏI
			if(i<index_max && diff<-allowed_unevenness)
				return;

			// maxlꂽallowed_unevennessӏ΂ŏI
			if(i>index_max && diff>allowed_unevenness)
				return;
		}


		// R`̍ȏłȂ΂ŏI
		// [̒lƔr(_班Βl͗hȂ̂Ȃ̂ō[ƌߑł)
		if(maxValue<(ad_array_fixed[0]+HEIGHT_DIFF))
			return;

		// E[̒lƔr(_班Βl͗hȂ̂Ȃ̂ŉE[ƌߑł)
		if(maxValue<(ad_array_fixed[WINDOW_SIZE-1]+HEIGHT_DIFF))
			return;


		// 햬õz[h\̏ꍇ͂ŏI
		if(counter_hold)
			return;


		// s[N()o

		misalign_last=WINDOW_SIZE-index_max;
		counter_last=counter_last-misalign_last+misalign_bef_last;
		misalign_bef_last=misalign_last;

		if(counter_bef_past && (!flg_just))
			flg_fill = 1;
		else if(counter_bef_past && flg_just)
		{
			counter_bef_past = 0;	// Tv1͐MႢ̂Ŏ̂Ă
			flg_fill = 0;
			flg_just = 0;
		}
		else
		{
			flg_fill = 0;
			flg_just = 1;
		}

		sum=counter_bef_past;
		sum+=counter_past;
		sum+=counter_bef_last;
		sum+=counter_last;

		counter_bef_past = counter_past;
		counter_past = counter_bef_last;
		counter_bef_last = counter_last;
		counter_last = 0;

		if(sum && flg_fill)
		{
			pulse_bef_bef_past = pulse_bef_past;
			pulse_bef_past = pulse_past;
			pulse_past = pulse;
			pulse=12000/sum;


			pulse_disp = pulse;


			if(counter_hold == 0)
			{
				if(pulse > 40)
				{
					if(pulse_bef_bef_past && pulse_bef_past && pulse_past)
					{

						pulse_min = pulse;
						if(pulse_min >= pulse_past)
							pulse_min = pulse_past;
						if(pulse_min >= pulse_bef_past)
							pulse_min = pulse_bef_past;
						if(pulse_min >= pulse_bef_bef_past)
							pulse_min = pulse_bef_bef_past;

						pulse_max = pulse;
						if(pulse_max < pulse_past)
							pulse_max = pulse_past;
						if(pulse_max < pulse_bef_past)
							pulse_max = pulse_bef_past;
						if(pulse_max < pulse_bef_bef_past)
							pulse_max = pulse_bef_bef_past;

						pulse_diff = pulse_max - pulse_min;

						// 4̖̍ŏEőԂ̍ȓ̏ꍇ
						if(pulse_diff<=ALLOWED_PULSE_DIFF)
						{
							pulse_sum = pulse_bef_bef_past + pulse_bef_past + pulse_past + pulse;
							pulse_stable = pulse_sum / 4;
							pulse_disp = pulse_stable;
							pulse_bef_past = 0;
							pulse_past = 0;
							counter_hold = DISP_HOLD_COUNTER_NUM;
							flg_beep = 1;
							LIGHT=LIGHTON;
						}
					}
				}
			}
			else
				pulse_disp = pulse_stable;

		}

		if(counter_hold || (!flg_max))
		{
			LED=LEDON;
			if(counter_hold)
				counter_beep=BEEP_HOLD_PERIOD;
			else
				counter_beep=BEEP_PERIOD;

			SetDCPWM1 (PWM_DS);

			if(flg_fill)
				sprintf(Buf, "%5d", pulse_disp);
			else
				sprintf(Buf, "     ");	// l͔\ŃuU[
/*
			if(counter_hold)
				sprintf(Buf, "%3d,%3d", pulse_disp, pulse_diff);
*/
		}
		else
		{	// O܂ADlOaĂꍇ͂܂MłȂlƂ݂Ȃo͂񌩑
			flg_max=0;
			sprintf(Buf, "     ");
		}


	    LCD_posyx(0,0);
		for(i=0;i<5;i++)
		{
    		LCD_dat(Buf[i]);
		}
		LCD_dat('b');
		LCD_dat('p');
		LCD_dat('m');

		skip_cntr=SKIP_SIZE;

    }
}

void interrupt low_priority LowInterrupt(void)	//Low priority interrupt
{
}

/******************************************************************************
 * Function:        void InitializeUSART(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This routine initializes the UART to 19200
 *
 * Note:            
 *
 *****************************************************************************/
void InitializeUSART(void)
{
	    unsigned char c;
        #if defined(__18F14K50)
    	    //ANSELHbits.ANS11 = 0;	// Make RB5 digital so USART can use pin for Rx
            ANSELH = 0;
            #ifndef BAUDCON
                #define BAUDCON BAUDCTL
            #endif
        #endif

        UART_TRISRx=1;				// RX
        UART_TRISTx=0;				// TX
        TXSTA = 0x24;       	// TX enable BRGH=1
        RCSTA = 0x90;       	// Single Character RX
        SPBRG = 0xA0;
        SPBRGH = 0x01;      	// 0x01A0 for 32MHz -> 19200 baud
//        SPBRG = 0x40;
//        SPBRGH = 0x03;      	// 0x0340 for 32MHz -> 9600 baud
//        SPBRG = 0x08;
//        SPBRGH = 0x02;      	// 0x0208 for 20MHz -> 9600 baud
//        SPBRG = 0x37;
//        SPBRGH = 0x01;      	// 0x0137 for 12MHz -> 9600 baud
//        SPBRG = 0xCF;
//        SPBRGH = 0x00;      	// 0x00CF for 8MHz -> 9600 baud
        BAUDCON = 0x08;     	// BRG16 = 1
        c = RCREG;				// read 

}//end InitializeUSART

#define mDataRdyUSART() PIR1bits.RCIF
#define mTxRdyUSART()   TXSTAbits.TRMT

/******************************************************************************
 * Function:        void putcUSART(char c)
 *
 * PreCondition:    None
 *
 * Input:           char c - character to print to the UART
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        Print the input character to the UART
 *
 * Note:            
 *
 *****************************************************************************/
void putcUSART(char c)  
{
	TXREG = c;
}


void UART_putc(unsigned char c)
{
	TXSTAbits.TXEN=0;// disable transmission
	TXREG=c;            // load txreg with data
	TXSTAbits.TXEN=1;    // enable transmission
	while(TXSTAbits.TRMT==0) // wait here till transmit complete
	{
		Nop();
	}
}
/******************************************************************************
 * Function:        void getcUSART(char c)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          unsigned char c - character to received on the UART
 *
 * Side Effects:    None
 *
 * Overview:        Print the input character to the UART
 *
 * Note:            
 *
 *****************************************************************************/
unsigned char getcUSART ()
{
	char  c;

	if (RCSTAbits.OERR)  // in case of overrun error
	{                    // we should never see an overrun error, but if we do, 
		RCSTAbits.CREN = 0;  // reset the port
		c = RCREG;
		RCSTAbits.CREN = 1;  // and keep going.
	}
	else
    {
		c = RCREG;
    }
// not necessary.  EUSART auto clears the flag when RCREG is cleared
//	PIR1bits.RCIF = 0;    // clear Flag

	return c;
}
